# [Powerflutter](https://www.powerflutter.com)

Powerflutter is an easy to use yet powerful framework for Flutter & Dart focussing on developer productivity.

Powerflutter wants to be what Rails is for Ruby, the go to Framework that makes all common Tasks easier. The focus is keeping things simple, developer productivity high, writing less boilerplate code, and getting maintainable, testable code.

Powerflutter will in the future give you the option to write your custom server code in dart using the Powerflutter Server Library. 

Furthermore Powerflutter has an optional code generation library
that will generate any even small boilerplate code and typed references to assets like images, sounds or localizations instead of manually added string based approaches which break easily and dont have compile time checks.


## Getting Started

Examples and gettings Started Guides can be found in the [Powerflutter Examples Repo](https://github.com/Powerflutter/powerflutter_examples).

## Features & Roadmap for 2019

[X] Powerful and easy State management using automatic databinding

[X] Dependency Injection 

[X] Eventbus to send events inside the application

[X] toJson and fromJson for automatic JSON serialization

[X] automatic saving of Application State to SharedPreferences with one line of Code

[ ] Saving & loading of data with referential Integrity using UUIDs

[ ] Firebase integrations with automatic loading & saving, data comes as strongly typed

[ ] Powerful and easy Animations 

[ ] Powerful and easy Localization

[ ] Support for Flutter Web once it is merged into the stable branch

[ ] much more

## [Powerflutter Code Generation](https://github.com/Powerflutter/powerflutter_code_generation)
    [X] Model getter/setter code generation annotations
    [ ] Strongly typed access to all your assets 


## [Powerflutter Server](https://github.com/Powerflutter/powerflutter_server), write your server code in Dart with perfect client integration:
    [ ] Share your logic and classes from client&server
    [ ] Get the server running in minutes, easy to user yet powerful
    [ ] Realtime (web)socket connections (alternativ traditional http connection)
    [ ] Sending and receiving strongly typed objects, with automatic serialization and deserialization
    [ ] Rooms that notify participants when somethings happens
    [ ] Shared Objects, change data on the server from the client (and for other clients int the same room) by using assigning properties on an object without the need to send requests or handle responses (with access management) 
    [ ] Server Hot Reload
    [ ] DB Integrations / ORM / Querying 

## Optional Powerflutter.com hosted Services:
    [ ] Service for remote Localization updates. Change your Strings on the fly or add new languages not App Update needed. Full offline capable fallback and only send the minimum updates needed.
    [ ] Build a community that helps each other localise their apps for free (e.g. you localise mine in spanish, I localise yours in german)
    [ ] Service for remote Configuration Updates, 
    [ ] Replace Images, Sounds on the fly

[ ] more examples

[ ] much more, any wishes? 


## Apps build with Powerflutter

Moves - design your play: [Android](https://play.google.com/store/apps/details?id=com.coachbetter.tacticboard) 